#include <iostream>
using namespace std;
#define MAX 50
// Estrutura Produto
struct Produto {
    int id;
    int qtd;
    int min;
    float preco;
};


struct Pilha {
    Produto v[MAX];
    int topo;
};


int empilhar(Pilha &p, Produto valor);
int desempilhar(Pilha &p, Produto &valor);
void imprime(Produto p);
void preenche(Produto &p);

int main(void) {
    Produto prod;
    int n, i;
    Pilha pilha;
    pilha.topo = -1;

    cout << "Quantos produtos cadastrar?" << endl;
    cin >> n;

    for (i=0; i<n; i++) {
        preenche(prod);
        empilhar(pilha, prod);
    }

    while ( desempilhar(pilha, prod) == 0 ) {
        imprime(prod);
    }
}

void preenche(Produto &p) {
    cout << "Digite o ID: ";
    cin >> p.id;
    cout << "Digite a quantidade: ";
    cin >> p.qtd;
    cout << "Digite a quantidade minima: ";
    cin >> p.min;
    cout << "Digite o preco: ";
    cin >> p.preco;
}

void imprime(Produto p) {
    cout << "********" << endl;
    cout << "ID:    " << p.id << endl;
    cout << "Qtd:   " << p.qtd << endl;
    cout << "Min:   " << p.min << endl;
    cout << "Preco: " << p.preco << endl;
}

int empilhar(Pilha &p, Produto valor) {
    // Verifica se a pilha est cheia
    if ( p.topo == MAX-1 ) return 1;
    // Se no est...
    p.topo = p.topo + 1;
    p.v[p.topo] = valor;
    return 0;
}

int desempilhar(Pilha &p, Produto &valor) {
    // Verificar se a pilha est vazia
    if ( p.topo == -1 ) return 1;
    // Se no est
    valor = p.v[p.topo];
    p.topo = p.topo - 1;
    return 0;
}

