#include <iostream>
using namespace std;

#define MAX 50

struct Pilha {
    int v[MAX];
    int topo;
};

int empilhar(Pilha &p, int v);
int desempilhar(Pilha &p, int &v);

int main(void) {

    // Declara e inicializa a pilha
    Pilha p;
    p.topo = -1;

    // Dado de entrada
    int tmp;

    do {
        cout << "Digite no.: ";
        cin >> tmp;
        empilhar(p,tmp);
    } while (tmp != 0);


    cout << "Resultado:" << endl;
    while( desempilhar(p, tmp) == 0 ) {
        cout << tmp << " ";
    }

}

// Empilha elemento
int empilhar(Pilha &p, int v) {
    // Verifica se est cheia
    if (p.topo == MAX-1) return 1;
    // Se no est cheia, empilha
    p.topo++;
    p.v[p.topo] = v;
    return 0;
}

// Desmpilha elemento
int desempilhar(Pilha &p, int &v) {
    // Verifica se est vazia
    if (p.topo == -1) return 1;
    // Se no est vazia, desempilha
    v = p.v[p.topo];
    p.topo--;
    return 0;
}
